<?php
require('cfg/auth.php');
require('cfg/db.php');
require('cfg/validation.php');
require('cfg/parse.php');
require('cfg/db_functions.php');
require('cfg/pagination_sort.php');

$table = 'px_papers';

$login_flag = sess_check();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo $px_name; ?> - Browse Papers</title>
<link rel="stylesheet" type="text/css" href="../style.css">
<link rel="stylesheet" type="text/css" href="px.css">
<script language="JavaScript" type="text/javascript" src="forms.js">
</script>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>

<?php
include('../ssi/header_u1.txt');
?> 
<table border="0" cellspacing="0" cellpadding="3" width="700">
<tr>

<?php
include('../ssi/navigation_u1.txt');
?> 
<td valign="top">
<!-- main content ### -->
<?php
include('includes/px_top.php');
?>

<div class="papers1">
<div class="header3">Browse Papers</div>

<?php
db_connect($dbhost, $dbuser, $dbpass);

//
// Use a switch on $_GET['action']
//
if (isset($_GET['action'])) {

switch($_GET['action']) {


//
// for viewing paper records
//
	case 'view':
	//
	// check for paper ID
	if(!isset($_GET['pid'])) {
	echo 'No paper specified.';
	}

	//
	// otherwise, go!
	else {
	
	$pid = $_GET['pid'];
	validate_id($pid);

	if(isset($_GET['r'])) {
	$url = 'browse.php?action=browse&pf=' . @$_GET['pf'] . '&sort=' . @$_GET['sort'] . '&pg=' . @$_GET['pg'];
	}
	elseif(isset($_GET['s'])) {
	$url = 'search.php?type=paper&sf=' . @$_GET['sf'] . '&o=' . @$_GET['o'] . '&sort=' . @$_GET['sort'] . '&pg=' . @$_GET['pg'] . '&q=' . @$_GET['query'];
	}
	else {
	$url = 'browse.php';	
	}
	
	// basic paper information
	$sql = "SELECT PaperTitle, Abstract, Citation, Notes, SubmittedBy, UpdatedBy, DATE_FORMAT(DateSubmitted, '$date_time_short'), DATE_FORMAT(DateModified, '$date_time_short'), Links FROM $table WHERE PaperID = '$pid'";
	
	if(@$row = mysql_fetch_row(mysql_query($sql))) {
	echo '<a href="' . $url . '">Browse Papers</a> &gt; Viewing Paper \'' . htmlspecialchars(truncate($row[0], 35), ENT_NOQUOTES) . '\'<br /><br />
	<span class="subheader">' . htmlspecialchars($row[0], ENT_NOQUOTES) . '</span><br /><br />
	<strong>Citation:</strong><br /> ' . parse_html($row[2]) . '<br /><br /><br />
	<strong>Abstract:</strong><br /> ' . parse_html($row[1]) . '<br /><br /><br />';
	
	if($row[3] != '') { echo '<strong>Additional Notes:</strong><br /> ' . parse_html($row[3]) . '<br /><br /><br />'; }
	
	echo '<strong>Other Information:</strong><br />
	Added by: ' . $row[4] . ' ' . $row[6] . '<br />
	Last modified by: ' . $row[5] . ' ' . $row[7] . '<br /><br /><br />';
	}

	else {
	die('Database error or invalid paper ID specified.<br /><br />' . mysql_error());
	}
	
	
	//	bottom part of page
	echo '<table class="browseTable"><tr>';
	
	// if there are links, parse them!
	if($row[8] != '') {
	echo '<td width="200" class="browseCell" id="1"><strong>Links:</strong><br />';
	$links = explode('|', $row[8]);
	$max = sizeof($links);
	
	for ($x = 0; $x <= ($max-1); $x++) {
		$eachLink = explode(',', $links[$x]);
		echo '<a href="' . $eachLink[0] . '">';
		
		if ($eachLink[1] != '') { echo truncate($eachLink[1], 30) . '</a>'; }
		else { echo substr($eachLink[0], 0, 30) . '...</a>'; }

		if ($eachLink[2] != '') { echo '<div style="margin-left: 30px;">' . htmlspecialchars($eachLink[2], ENT_NOQUOTES) . '</div>'; }

		echo '<br /><br />';		
		}
		
	echo '<br /><br /></td>';
	}
	
	//
	// retrieve information on files
	
	$numRows = db_get_record_count_select('px_files', 'FileID', 'PaperID', $pid);
	
	if ($numRows == 0) {
	// do nothing
	}
	
	else {
	echo '<td class="browseCell" id="2"><strong>Files</strong><br />';
	$sql = mysql_query("SELECT FileID, FileTitle, FileName, FileSize, FileType, DownloadCount FROM px_files WHERE PaperID = '$pid' ORDER BY DateAdded DESC");
	while ($row = mysql_fetch_row($sql)) {
	echo '	<a href="files.php?action=dl&fid=' . $row[0] . '">' . $row[1] . '</a><br />
	<div style="margin-left: 35px;">[' . $row[2] . ': ' . $row[4] . ']<br />
	<a href="files.php?action=viewinfo&fid=' . $row[0] . '">Details</a> | ' . parse_filesize($row[3]) . ' | Downloads: ' . $row[5] . '</div><br />';
	}
	
	echo '</td>';
	
	}

	echo '</td></tr></table>';
	//
	// end display of paper data
	}
	break;

//
// browse papers
//
	case 'browse':
	// get variables first!
	if(!isset($_GET['pg'])) { $page = 1; }
	else { $page = trim($_GET['pg']); }

	if(isset($_POST['PaperField'])) {
	$papersort = trim($_POST['PaperField']);
	if ($papersort == -1) { $papersort = 'PaperTitle'; }
	}
	elseif(isset($_GET['pf']) && $_GET['pf'] != '') { $papersort = trim($_GET['pf']); }	
	else { $papersort = 'PaperTitle'; }
	
	if(isset($_POST['Sort'])) {	$sort = trim($_POST['Sort']); }
	elseif(isset($_GET['sort']) && $_GET['sort'] != "") { $sort = trim($_GET['sort']); }
	else { $sort = "DESC"; }

	validate_alpha($sort);
	validate_alpha($papersort);
	
	// check for records
	
	$numRows = mysql_num_rows(mysql_query("SELECT PaperID FROM $table"));
	$pvars = page_vars($numRows, $per_page, $page);

	// display data if there are records
	if ($numRows <= 0) {
	echo 'No papers found.<br /><br />';
	}
	
	else {
	echo 'Found ' . $numRows . ' paper(s).  Displaying papers ' . ($pvars['start']+1) . ' through ' . ($pvars['end']+1) . '.<br /><br />';
	
	generate_navigation($pvars['num_pages'], $pvars['page'], 'browse.php?action=browse&pf=' . $papersort . '&sort=' . $sort . '&');
	
	echo '<br /><br /><img src="images/bpixel.gif" width="450" height="1" alt="- - -" /><br /><br />';
		
	$sql = mysql_query("SELECT PaperID, PaperTitle, Citation, SubmittedBy, DATE_FORMAT(DateSubmitted, '$date_short') FROM $table ORDER BY $papersort $sort LIMIT " . $pvars['start'] . ", $per_page");
	
	while ($row = mysql_fetch_array($sql)) {
	echo '<strong>' . $row[1] . '</strong><br />' .
	$row[2] . '<br />
	<a href="browse.php?action=view&r=1&pf=' . $papersort . '&sort=' . $sort . '&pg=' . $page . '&pid=' . $row[0] . '">More Information</a> || Submitted by: ' . $row[3] . ' ' . $row[4] . '<br /><br />';
	}
	}

	echo '<img src="images/bpixel.gif" width="450" height="1" alt="- - -" /><br /><br />
	<form name="browse" action="browse.php?action=browse" method="POST">';
	gen_browse($papersort, $sort);
	echo '<input type="submit" value="Submit" name="browse" /></form>';
	break;

	//
	// default
	default:
	echo 'No defined function specified.';
	break;
}

}

else {
//
// default action is to browse papers - display form for browsing
//


echo 'To view paper records, please select the field by which you would like to view them: <br />
<form name="browse" action="browse.php?action=browse" method="POST">';
gen_browse(NULL, NULL);
echo '<input type="submit" value="Submit" name="browse" /></form>';

}

include('includes/px_bottom.php');
?>
</div>

<!-- #################
############## footer#
###################### -->
<?php
include('../ssi/footer_u1.txt');
?> 

</td></tr></table>

</body>
</html>