<?php
// #######################################################################
// biocomplexity.indiana.edu [august 2003]								 #
// paper exchange														 #
// #######################################################################
// cfg/pagination_sort.php - pagination and sorting of record results    #
// #######################################################################

// page_gen_vars - process and then output the variables necessary for pagination in an array
function page_vars($numRecords, $per_page, $page) {

$num_pages = ceil($numRecords/$per_page);

if(!is_numeric($page)) {
$page = 1;
}

if ($page > $num_pages or $page <= 0) {
$page = 1;
}

$start = ($page*$per_page) - $per_page;
$end = ($start + $per_page) - 1;

if ($page == $num_pages) {
$cur_records = $per_page*($num_pages-1);
$per_page = $numRecords - $cur_records;
$end = ($cur_records + $per_page) - 1;
}

$pagination_vars = array("page" => $page, "start" => $start, "end" => $end, "num_pages" => $num_pages);

return $pagination_vars;

}
// #############################################################


//
//	generate navigation - generates navigation so that users may navigate results
//
function generate_navigation ($num_pages, $page, $url) {
if ($page != 1) {
echo '<a href="' . $url . 'pg=' . ($page-1) . '">&#171; Previous</a> || ';
}
else {
echo '&#171; Previous || ';
}

for ($x = 1;  $x <= $num_pages; $x++) {

if ($page == $x) {
echo ' <strong>' . $x . '</strong> |';
}

else {
echo ' <a href="' . $url . 'pg=' . $x . '">' . $x . '</a> |';
}

}

if ($page == $num_pages) {
echo '| Next &#187;';
}

else {
echo '| <a href="' . $url . 'pg=' . ($page+1) . '">Next &#187;</a>';
}

}
// #################################################################

//
// generate form for searching papers
//
//
// generate form for browsing papers
//
// function gen_browse - generate sort by list
function gen_search($selected, $orderby, $sort) {

$paper_fields = array('PaperID', 'PaperTitle', 'Abstract', 'Citation', 'SubmittedBy', 'UpdatedBy', 'DateSubmitted', 'DateModified');
$paper_fields_friendly = array('Paper ID No', 'Paper Title', 'Paper Abstract', 'Paper Citation', 'Papers Submitted by User', 'Papers Updated by User', 'Date Submitted', 'Date Last Modified');

$orderby_fields = array('PaperID', 'PaperTitle', 'SubmittedBy', 'Updated By', 'DateSubmitted', 'DateModified');
$orderby_fields_friendly = array('Paper ID No', 'Paper Title', 'User Who Submitted the Paper', 'User Who Last Modified the Paper', 'Date Submitted', 'Date Last Modified');

echo '<form name="searchForm" action="search.php?type=paper" method="POST" onsubmit="return checkSearchForm()"> 
Search: <input type="text" maxlength="128" name="query"> Search field: <select size="1" name="PaperField" class="sbox">';

// if the selected/orderby variables have not been specified yet


// generate search field selector


for ($x = 0; $x <= 7; $x++) {
if ($selected == $paper_fields[$x]) {
echo '<option value="' . $paper_fields[$x] . '" selected>' . $paper_fields_friendly[$x] . '</option>';
		}
else {
echo '<option value="' . $paper_fields[$x] . '">' . $paper_fields_friendly[$x] . '</option>';
		}
	}

echo '</select><br /><br />
Order results by: ';

echo '<select size="1" name="OrderBy" class="sbox">';

for ($x = 0; $x <= 5; $x++) {
if ($orderby == $orderby_fields[$x]) {
echo '<option value="' . $orderby_fields[$x] . '" selected>' . $orderby_fields_friendly[$x] . '</option>';
		}
else {
echo '<option value="' . $orderby_fields[$x] . '">' . $orderby_fields_friendly[$x] . '</option>';
		}
	}

echo '</select> <select size="1" name="Sort" class="sbox">';

if(isset($sort) && $sort == "DESC"){
echo '<option value="ASC">Ascending</option>';
echo '<option value="DESC" selected>Descending</option>';
	}
else {
echo '<option value="ASC" selected>Ascending</option>
<option value="DESC">Descending</option>';
	}

echo '</select><br /><br />
<div align="right"><input type="submit" value="Search" name="search"></div></form>';
}


//
// generate form for browsing papers
//
// function gen_browse - generate sort by list
function gen_browse($selected, $sort) {

$paper_fields = array('PaperTitle', 'Abstract', 'Citation', 'SubmittedBy', 'UpdatedBy', 'DateSubmitted', 'DateModified');
$paper_fields_friendly = array('Paper Title', 'Paper Abstract', 'Paper Citation', 'Papers Submitted by User', 'Papers Updated by User', 'Date Submitted', 'Date Modified');

echo '<select size="1" name="PaperField" class="sbox">';

// if $selected is not NULL, generate list with selected option selected
if (isset($selected)) {
echo '<option value="-1">Browse Papers by:</option>';

for ($x = 0; $x <= 6; $x++) {
if ($selected == $paper_fields[$x]) {
echo '<option value="' . $paper_fields[$x] . '" selected>' . $paper_fields_friendly[$x] . '</option>';
		}
else {
echo '<option value="' . $paper_fields[$x] . '">' . $paper_fields_friendly[$x] . '</option>';
		}
	}
}

// otherwise generate list with nothing selected
else {
echo '<option value="-1" selected>Browse Papers by:</option>';

for ($x =0; $x <= 6; $x++) {
echo '<option value="' . $paper_fields[$x] . '">' . $paper_fields_friendly[$x] . '</option>';
}
}

echo '</select>
<select size="1" name="Sort" class="sbox">';

if(isset($sort) && $sort == "DESC"){
echo '<option value="ASC">Ascending</option>';
echo '<option value="DESC" selected>Descending</option>';
}

else {
echo '<option value="ASC" selected>Ascending</option>
<option value="DESC">Descending</option>';
}

echo '</select>  ';
}


?>