<?php
// validate numeric ID!
function validate_id($id) {

if (!ereg("^[0-9]+$", $id)) {
	die('Invalid ID specified.');
}
}

// validate for A-Za-z only
function validate_alpha($input) {

if(!ereg("^[A-Za-z]+$", $input)) {
	die('Invalid input.');
	}
}

// validate URL - only a basic validation, not exhaustive

function validate_url($url) {
// ^(http|https|ftp):\/\/([A-Za-z]+\.*){2,}|([1-9]{1}[0-9]{1}\.?){4}|([1-2]{1}[0-9]{2}\.?){4}(\/\w+\.*\w*|\/w+|\/*)*(\/)*$
//
if(!preg_match("/^(http|https|ftp):\/\/(([A-Za-z]+\.){1,}([A-Za-z]+){1})|([1-9]{1}[0-9]{1}\.?){4}|([1-2]{1}[0-9]{2}\.?){4}(\/\w+\.*\w*|\/w+|\/*)*(\/)*$/", $url)) {
	return false;
	}
else {
	return true;
}	
}

// check_post_data

function check_post_data($subject, $message) {
	if(strlen($subject) > 60) {
	echo 'The subject you have entered is too long; the subject must be 60 characters or less.  Please go back and change this.';
	p_error();
	}

	if(strlen($message) > 65535) {
	echo 'The message you have entered is too long; the subject must be 65535 characters or less.  Please go back and change this.';
	p_error();
	}
}



// validate query - allow spaces and alphanumeric characters
function validate_query($query) {

if (!preg_match("/^\w+(\s\w+)*\w*$/", $query)) {
	die('Illegal characters in the query.  Only alpha-numeric characters and spaces are permitted.'); 
	}

}

// e-mail address validation
function validate_email($email) {

if(strlen($email) > 60) {
die('The e-mail addressed entered is too long; the maximum length of the field is 128 character or less.');
}

if (!ereg("^[[:alnum:]]+([\.-_]?[[:alnum:]]+)*@[[:alnum:]]+([\.-]?[[:alnum:]]+)*(\.[a-z]{2,})+$", $email)) {
	die('Invalid e-mail address specified.');
}

}

// username validation
function validate_username($username) {

if(strlen($username) > 30) {
	die('The user name entered is too long; the maximum length thereof is thirty characters.');
}

if (!ereg("^[[:alnum:]!@\$#\.\*]+([_!@\$#-\.\*]?[[:alnum:]]+)*[[:alnum:]!@\$#\.\*]+$", $username)) {
	die('Invalid username.');

}

}

// password validation
function validate_password($pass) {

if (strlen($pass) < 6) {
	die('The password must be at least six characters in length.');
}
elseif (strlen($pass) > 32) {
	die('The password is too long.');
}

if (!ereg("^[[:alnum:]_!@#\.\*\$]+$", $pass)) {
	die('Invalid password entered.');
}

}

// name validation
function validate_name($name) {

if(strlen($name) > 35) {
	die('The name entered is loo long; the maximum length of the field is thirty-five characters.');
}

if(!preg_match("/^(\w+|(\w{1,3}\.)+)(\s?\w+)*(\s?\w+\s)*(\s?\w{1,3}\.\s)*(\w+|(\w{1,3}\.)+)$/", $name)){
	die('Invalid name.');
}

}

// validation of image URL
function validate_img_url($imgURL) {

if(strlen($imgURL) > 64) {
	die('The image URL entered is too long.  Please go back and correct this.');
	}

if(!preg_match("/^\w+\.(gif|jpg|jpeg|png)$/", $imgURL)) {
	die('Invalid image URL entered.');
	}
	
}


// validate input for paper add/edit forms
function validate_paper_input($CategoryID, $ImgURL, $PaperNo, $LinkNo, $PaperID) {

if ($CategoryID == "-1" || $CategoryID == 'all') {
	echo '<a href="add_data.php">&lt; Back</a><br><br>' .
	'Please go back and select a category.';
	exit();
}

if ($ImgURL != '') {
if(strlen($ImgURL) > 64) {
	die('The image URL entered is too long.  Please go back and correct this.');
	}

if(!preg_match("/^\w+\.(gif|jpg|jpeg|png)$/", $ImgURL)) {
	die('Invalid image URL entered.');
	}
}

if (!is_numeric($PaperNo)) {
die ('The paper number entered was not a valid integer.');
}

if ($PaperID !='') {
if (!is_numeric($PaperID)) {
die ('The paper ID entered was not a valid a integer.');
}
}

if ($LinkNo != '') {
if (!is_numeric($LinkNo)) {
die ('The link number entered was not a valid integer.');
	}
}

}
// ################################################

// validate categories form
function validate_categories_input($category, $categoryID) {
if($category == '') {
	die('Please enter a category.');
}
else {
	if(!preg_match("/^\w+[\w\s-]+\w$/", $category)) {
	die('Invalid category entered.  Please ensure that only alphanumeric characters are present in the category field.');
	}
}

if($categoryID == '') {
	die('Please enter a category ID.');
}
else {
	if(!preg_match("/^[A-Za-z0-9]+$/", $categoryID)) {
	die('Invalid category ID entered.  Please ensure that only alphanumeric characters are present in the category ID.');
	}
}

}

// add slashes to allow for valid MySQL query
function add_slashes($input) {
$input = str_replace('\\', '', $input);
$input = str_replace('`', '\`', $input);
$input = str_replace('~', '\~', $input);
$input = str_replace('\'', '\\\'', $input);
return $input;
}
// ############################################


?>